# What is SCM/VCS?

SCM (Source Control Management) and VCS (Version Control System) are interchangeable terms used for systems that manage changes to the source code of software.

If you've written any code you'll know that in the end any feature, bug-fix or any change to software usually boils down to changes across a number of text files. Whether you work on Python, Ruby, JavaScript, C++, C#, Java or any other programming language, you'll be making changes to your code over time.

Often in order to understand why something doesn't work the way it used to, it can be invaluable to see the state of your code as it was days, weeks, or even months ago. When you run into such an issue, you'll quickly realise that the undo button of your editor only goes so far.

The simplest solution here is to keep copies of your code at different points as it changes. If you take a backup after each logical change to your software, after it's in a running state and has been tested you will have a way to see your code as it exists at different points of time.

This is essentially what SCM/VCS software is specialised to do by storing this information in a hidden folder along with your code. It also keeps this information in a condensed form so it's easier to store and transmit.

SCM/VCS software, like Git, are tools that are specialised to keep track of changes to code and other artefacts. They allow easy switching between the code versions at different points of time in its history. While you can store different file types in version control systems, they are usually optimised to handle text files and are most efficient to track changes within those files.

When you use such a tool, you will generally make some changes, use the commands or UI the tool provides to save/commit the changes to a "repository" along with a message describing the changes you've just made. A repository in this case is just a set of data files that stores the history of changes made to your code.

## Working with others

One important aspect of developing software we've left out so far here is working with others. When working on any software, and especially when working on open source software, you need to work with other people.

For multiple people to work together they all need access to the latest version of the code at all times so that they can work on it. Even so, as different people work on different parts of the code, they will undoubtedly end up in situations where they make conflicting changes, or when one two people are working on different versions of the same code base.

If you were manually maintaining copies of your code, this could become unwieldy as different people could be making different changes in the code, and you'd need to merge them together regularly. For instance if Alice and Bob needed to work on the same code at the same time, they'd both make backups of the existing code, make changes, however Alice wouldn't have Bob's changes and vice-versa, they'd need to coordinate with each other to make sure the final product includes both changes.

When using an SCM the tool will often help you see and track only the changes you've made to the code. It will make it clear to people when files they haven't accounted for have changed, or if two people have made changes to the same files. If two or more people have changed the same file(s) they can often handle that gracefully as well unless the differences overlap with each other.

Such tools will often warn you when you run into such conflicting situations so you can incorporate the changes others have made into your own code and add changes to your updates in case needed.

## A brief intro to Git

If you've heard of the term SCM, VCS or have heard of GitHub you might have also heard of Git.

Git is a VCS/SCM that has become the de-facto standard for version control. The history of version control is filled with other tools such as CVS, SVN, Perforce, BitKeeper, Bazaar, Fossil, Mercurial, etc, Git is one of the latest generation tools that incorporated the trends and ways people work on software collaboratively and gained high popularity. If you work on software it won't be long before you will be introduced to it.

The history of Source Control software is long, but given it's immense popularity we will focus mostly on Git.

Since version control software are designed to not only help you track changes to code over time, but also work together with others on the same code, it traditionally operated in a centralised manner.

With CVS and SVN for instance you'd need to run a server that would maintain the history of the code, and would also allow developers to "lock" files so that only one person could modify a file at a time. If this central server was offline, you could no longer see the history of the code, or save any changes to the code history.

Modern VCS software like Git take a different decentralised approach. Instead of requiring a single central place for maintaining all the source code history and metadata, and only keeping minimal information locally with the code, these tools keep everything locally.

When working with Git you can make changes, commit changes, and keep a full local history before interacting with another remote system.

In this sense the repository at a site hosting a Git repository like GitHub, isn't any different than a local copy. They may provide additional features for easily navigating the code and its history, or for reviewing changes, but those features layer over Git, they are not a part of it.

With Git you can send/sync changes between any two repositories, not just from your local copy to one hosted by GitHub for instance. That is how they earn the name of distributed version control systems (DVCS) even though often in common operation you still need some central place where you can collaborate with others.

It is important to note that Git isn't the only SCM you're likely to encounter out there. For open source software it is definitely the most popular, but you might also see SVN and Mercurial in use. In the closed source/proprietary world there are proprietary SCM/VCS tools like Perforce Helix, or Microsoft Visual SourceSafe that you might find in use.
